Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 459484 - app-shells/tcsh-6.17-r1: fails to build with ncurses[tinfo]
Summary: app-shells/tcsh-6.17-r1: fails to build with ncurses[tinfo]
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Fabian Groffen
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: tinfo
  Show dependency tree
 
Reported: 2013-02-27 12:00 UTC by Diego Elio Pettenò (RETIRED)
Modified: 2014-11-07 00:02 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Diego Elio Pettenò (RETIRED) gentoo-dev 2013-02-27 12:00:55 UTC
https://tinderboxlogs.s3.amazonaws.com/tbhs64.excelsior.flameeyes.eu/app-shells%3Atcsh-6.17-r1%3A20130227-115004.html

Portage 2.2.0_alpha161 (hardened/linux/amd64/no-multilib, gcc-4.6.3-asneeded, glibc-2.15-r3, 3.7.0-hardened x86_64)
=================================================================
System uname: Linux-3.7.0-hardened-x86_64-AMD_Opteron-TM-_Processor_6272-with-gentoo-2.1
KiB Mem:    65914672 total,  15864424 free
KiB Swap:          0 total,         0 free
Timestamp of tree: Thu, 31 Jan 2013 11:15:01 +0000
ld GNU ld (GNU Binutils) 2.22
distcc 3.1 x86_64-pc-linux-gnu [disabled]
ccache version 3.1.8 [disabled]
app-shells/bash:          4.2_p37
dev-java/java-config:     2.1.12-r1
dev-lang/python:          2.7.3-r2, 3.2.3
dev-util/ccache:          3.1.8
dev-util/cmake:           2.8.9
sys-apps/baselayout:      2.1-r1
sys-apps/openrc:          0.11.8
sys-apps/sandbox:         2.5
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.9.6-r3, 1.10.3, 1.11.6
sys-devel/binutils:       2.22-r1
sys-devel/gcc:            4.6.3
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4-r1
sys-devel/make:           3.82-r4
sys-kernel/linux-headers: 3.6 (virtual/os-headers)
sys-libs/glibc:           2.15-r3
Repositories: gentoo
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -ggdb -march=native -ftracer -frecord-gcc-switches"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/fax /usr/share/gnupg/qualified.txt /usr/share/openvpn/easy-rsa /usr/share/themes/oxygen-gtk/gtk-2.0 /var/lib/hsqldb /var/lib/neatx/home /var/spool/fax/etc /var/spool/munin-async/.ssh /var/yp/Makefile"
CONFIG_PROTECT_MASK="${EPREFIX}/etc/gconf /etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.3/ext-active/ /etc/php/apache2-php5.4/ext-active/ /etc/php/cgi-php5.3/ext-active/ /etc/php/cgi-php5.4/ext-active/ /etc/php/cli-php5.3/ext-active/ /etc/php/cli-php5.4/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/splash /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -pipe -ggdb -march=native -ftracer -frecord-gcc-switches"
DISTDIR="/var/cache/portage/distfiles"
FCFLAGS="-O2 -pipe -ggdb -march=native -frecord-gcc-switches"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fail-clean fixlafiles merge-sync news parallel-fetch protect-owned sandbox sfperms strict test test-fail-continue unknown-features-warn unmerge-orphans userfetch userpriv usersandbox"
FFLAGS="-O2 -pipe -ggdb -march=native -frecord-gcc-switches"
GENTOO_MIRRORS="http://ftp.ucsb.edu/pub/mirrors/linux/gentoo/ http://gentoo.mirrors.hoobly.com/ http://gentoo.llarian.net/"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j24"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/tmp"
PORTDIR="/var/cache/tinderbox/tree"
PORTDIR_OVERLAY=""
SYNC="rsync://excelsior.flameeyes.eu/gentoo-portage"
USE="3dnow 3dnowex acl amd64 berkdb bzip2 cli cracklib crypt curl cxx dri ffmpeg gdbm gpm hardened iconv introspection ipv6 justify mmx modules mudflap ncurses nls nptl openmp pam pax_kernel pcre plasma qt3support readline semantic-desktop session sse sse2 sse3 sse4 ssl ssse3 tcpd unicode urandom vhosts zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" PHP_TARGETS="php5-3" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_2" RUBY_TARGETS="ruby18 ruby19" USERLAND="GNU" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 1 Justin Lecher gentoo-dev 2013-05-03 21:54:40 UTC
tcsh-6.18.01-r1 (03 May 2013)

  03 May 2013; Justin Lecher <jlec@gentoo.org> +tcsh-6.18.01-r1.ebuild,
  metadata.xml:
  Add fix for compilation with ncurses[tinfo], #459484
Comment 2 Jeroen Roovers gentoo-dev 2013-12-26 17:26:04 UTC
When building against libtinfo, tcsh doesn't need libncurses.

After this change on a system with sys-libs/ncurses[tinfo]:

Index: tcsh-6.18.01-r2.ebuild
===================================================================
RCS file: /var/cvsroot/gentoo-x86/app-shells/tcsh/tcsh-6.18.01-r2.ebuild,v
retrieving revision 1.2
diff -u -B -r1.2 tcsh-6.18.01-r2.ebuild
--- tcsh-6.18.01-r2.ebuild      26 Dec 2013 17:17:21 -0000      1.2
+++ tcsh-6.18.01-r2.ebuild      26 Dec 2013 17:23:45 -0000
@@ -35,7 +35,7 @@
 
        # fix dependency on ncurses[tinfo], #459484
        sed \
-               -e "s:\(ncurses\):\1 tinfo:g" \
+               -e "s:ncurses:tinfo:g" \
                -i configure.in || die
 
        eautoreconf

I get:

# scanelf -n image/bin/tcsh 
 TYPE   NEEDED FILE 
ET_EXEC libtinfo.so.5,libcrypt.so.1,libc.so.6 image/bin/tcsh

So more work needs to be done, similar to net-irc/irssi (bug #453396)
Comment 3 Jeroen Roovers gentoo-dev 2013-12-26 17:56:42 UTC
Index: tcsh-6.18.01-r2.ebuild
===================================================================
RCS file: /var/cvsroot/gentoo-x86/app-shells/tcsh/tcsh-6.18.01-r2.ebuild,v
retrieving revision 1.2
diff -u -B -r1.2 tcsh-6.18.01-r2.ebuild
--- tcsh-6.18.01-r2.ebuild      26 Dec 2013 17:17:21 -0000      1.2
+++ tcsh-6.18.01-r2.ebuild      26 Dec 2013 17:54:46 -0000
@@ -16,11 +16,11 @@
 LICENSE="BSD"
 SLOT="0"
 KEYWORDS="~alpha ~amd64 ~arm hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~x86-fbsd ~x64-freebsd ~x86-freebsd ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
-IUSE="nls doc"
+IUSE="nls doc tinfo"
 RESTRICT="test"
 
 # we need gettext because we run autoconf (AM_ICONV)
-RDEPEND=">=sys-libs/ncurses-5.1
+RDEPEND=">=sys-libs/ncurses-5.1[tinfo=]
        virtual/libiconv"
 DEPEND="${RDEPEND}
        sys-devel/gettext
@@ -34,9 +34,11 @@
        epatch "${FILESDIR}"/${PN}-6.14-use-ncurses.patch
 
        # fix dependency on ncurses[tinfo], #459484
-       sed \
-               -e "s:\(ncurses\):\1 tinfo:g" \
-               -i configure.in || die
+       if use tinfo; then
+               sed \
+                       -e "s:ncurses:tinfo:g" \
+                       -i configure.in || die
+       fi
 
        eautoreconf

Index: metadata.xml
===================================================================
RCS file: /var/cvsroot/gentoo-x86/app-shells/tcsh/metadata.xml,v
retrieving revision 1.6
diff -u -B -r1.6 metadata.xml
--- metadata.xml        3 May 2013 21:54:17 -0000       1.6
+++ metadata.xml        26 Dec 2013 17:56:20 -0000
@@ -14,5 +14,6 @@
        </longdescription>
   <use>
     <flag name="catalogs">Add support for NLS catalogs</flag>
+    <flag name='tinfo'>Use only libtinfo from <pkg>sys-libs/ncurses</pkg></flag>
   </use>
 </pkgmetadata>
Comment 4 Justin Lecher gentoo-dev 2013-12-26 18:01:26 UTC
(In reply to Jeroen Roovers from comment #3)
> +IUSE="nls doc tinfo"

Why making this conditional? Is there a functionality reduction? If not I would vote for defaulting to link only the minimal lib.
Comment 5 Jeroen Roovers gentoo-dev 2013-12-26 18:04:22 UTC
(In reply to Justin Lecher from comment #4)
> (In reply to Jeroen Roovers from comment #3)
> > +IUSE="nls doc tinfo"
> 
> Why making this conditional? Is there a functionality reduction? If not I
> would vote for defaulting to link only the minimal lib.

With sys-libs/ncurses[-tinfo] you need to link against libncurses, and with sys-libs/ncurses]tinfo] you merely require linking against libtinfo. Some linkers will needlessly link against both the way the ebuild handles it now.
Comment 6 Justin Lecher gentoo-dev 2013-12-26 18:09:26 UTC
(In reply to Jeroen Roovers from comment #5)
 With sys-libs/ncurses[-tinfo] you need to link against libncurses, and with
> sys-libs/ncurses]tinfo] you merely require linking against libtinfo. Some
> linkers will needlessly link against both the way the ebuild handles it now.

Then I would simply depend on ncurses[tinfo] and drop USE=tinfo from tcsh. What is the benefit to have USE=tinfo for tcsh?
Comment 7 Fabian Groffen gentoo-dev 2013-12-26 19:17:54 UTC
(In reply to Justin Lecher from comment #6)
> (In reply to Jeroen Roovers from comment #5)
>  With sys-libs/ncurses[-tinfo] you need to link against libncurses, and with
> > sys-libs/ncurses]tinfo] you merely require linking against libtinfo. Some
> > linkers will needlessly link against both the way the ebuild handles it now.
> 
> Then I would simply depend on ncurses[tinfo] and drop USE=tinfo from tcsh.
> What is the benefit to have USE=tinfo for tcsh?

As Jeroen said, allows to use older versions.  How about, we dep on ncurses[tinfo] from the to be stabled 6.18.01, and leave 6.17 in a state where it can use normal ncurses (as is)?
Comment 8 Jeroen Roovers gentoo-dev 2014-03-03 20:18:03 UTC
After looking through this again, it seems the current solution in tcsh-6.18.01-r2 seems fine.
Comment 9 Jeroen Roovers gentoo-dev 2014-11-07 00:02:26 UTC
Fixed yes?